init:
    python:
        sys.setdefaultencoding('utf-8')
        readback_log_weeknum = -1
        def readback_log_newline():
            global readback_log_line
            if not (readback_log_line and readback_log_line[0].startswith('---')):
                readback_log_data.append(readback_log_line)
            readback_log_line = []
        
        def readback_log(s):
            global readback_log_weeknum
            try:
                if readback_log_weeknum!=weeknum:
                    readback_log_newline()
                    readback_log_data.append([_('Week: %d')%weeknum,])
                    readback_log_weeknum = weeknum
                    readback_log_line.append(s)
                elif s:
                    readback_log_line.append(s)
                else:
                    readback_log_newline()
            except:
                renpy_exports_log(s)
        readback_log_cursor = -1
        renpy_exports_log = renpy.exports.log
        renpy.exports.log = readback_log
        
        def htmlize(s):
            ret = ''
            for c in s:
                if c=='{':
                    ret += '<'
                elif c=='}':
                    ret += '>'
                #elif ord(c)>127:
                #    ret += '&#'+str(ord(c))+';'
                else:
                    ret += c
            return ret
        
        def htmlize_readback_log():
            html = '<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"></head><body>'
            for interaction in readback_log_data:
                if interaction:
                    br = True
                    if interaction[0].startswith('Choice: '):
                        html += _('Menu: ')
                        for nodule in interaction:
                            html += '['+nodule[8:]+'] '
                    elif interaction[0].startswith('User chose: '):
                        
                        html += _('Player chose: %s')% interaction[0][12:]
                    elif interaction[0].startswith('Week: '):
                        html += '<hr/>'+(_('Week %s')%interaction[0][6:])+'<br/>'
                    elif interaction[0].startswith('---'):
                        
                        br = False
                    elif len(interaction)==2:
                        html += htmlize(_(interaction[0])+': '+interaction[1])
                    else:
                        html += htmlize(': '.join(interaction))
                    if br:
                        html += '<br/>'
            html += '</body></html>'
            return html
        def save_log(filename='log.html'):
            global log_write_error
            html = htmlize_readback_log()
            try:
                f = file(renpy.config.savedir+'/'+filename,'wb')
                f.write(html)
                f.close()
                return True
            except Exception,e:
                try:
                    log_write_error = unicode(e).decode('utf-8')
                except:
                    log_write_error = '[error message could not be encoded]'
                    print "Error: Exception could not be encoded."
                    print e
                return False
        def open_log(filename=None):
            if filename is None:
                filename = renpy.config.savedir+'/log.html'
            try:
                import webbrowser
                webbrowser.open_new('file://'+filename)
            except:
                narrator(_("Error starting browser."))
label after_load:
    python:
        
        warnings = ''
        
        try:
            readback_log_data
        except:
            readback_log_data = []
            readback_log_line = []
            after_load_fixups = True
            warnings += "No log present in saved game.  Initializing.\n"
        try:
            flags
        except:
            warnings += "Flags not yet initialized.\n"
            flags = dict()
        try:
            lassi
        except:
            try: 
                
                lassi = 10000 - expenditures
                del expenditures
            except:
                pass
            warnings += "No lassi present in save game.  Setting to 10,000-expenditures.\n"
            after_load_fixups = True
        if 'army_size' not in flags:
            warnings += "Barracks not present in save game.  Initializing with military strength.\n"
            after_load_fixups = True
            flags['army_size'] = military_strength()
    if warnings:
        "%(warnings)s"
    return
label log_page:
    $ log_written = False
label log_page_menu:
    scene statsbg
    show expression PrincessSprite(mood,xanchor=.5)  at Position(xpos=.5)
    call show_calendar
    pass
    $ draw_sidebar(log='room_nofade')
    menu:
        "Continue":
            $ log_written = save_log()
            if log_written:
                python:
                    
                    log_file_name = renpy.config.savedir+'/log.html'
                    
                    
                    
                    open_log()
                    
                    log_file_name = log_file_name.decode('utf-8','replace')
                "Log saved to %(log_file_name)s\nStarting browser."
            else:
                "An error occurred saving the log.\n%(log_write_error)s"
        "Cancel":
            jump room_nofade_page
        "The game will now attempt to save the log and open it in a web browser."
    jump room_nofade_page
